#include "UniformBuffer.h"
#include <glad/glad.h>

namespace YoggieEngine {
	UniformBuffer::UniformBuffer(unsigned int size)
	{
		glGenBuffers(1, &Id);
		glBindBuffer(GL_ARRAY_BUFFER, Id);
		glBufferData(GL_ARRAY_BUFFER, size, nullptr, GL_DYNAMIC_DRAW);
		glBindBuffer(GL_ARRAY_BUFFER, 0);
	}

	UniformBuffer::~UniformBuffer()
	{
		glDeleteBuffers(1, &Id);
	}


	void UniformBuffer::setData(unsigned int offset, unsigned int size, void* data)
	{
		glBindBuffer(GL_ARRAY_BUFFER, Id);
		glBufferSubData(GL_ARRAY_BUFFER, offset, size, data);
		glBindBuffer(GL_ARRAY_BUFFER, 0);
	}

	void UniformBuffer::setDescriptor(unsigned int index, unsigned int size, unsigned int stride, void* pointer)
	{
		glBindBuffer(GL_ARRAY_BUFFER, Id);
		glVertexAttribPointer(index, size, GL_FLOAT, GL_FALSE, stride, pointer);
		glBindBuffer(GL_ARRAY_BUFFER, 0);
	}

}
