include("libraries")
print("Using Premake version ", _PREMAKE_VERSION)

workspace "Yoggie GameEngine"
	configurations { "Debug", "Test", "Release" } 

	language "C++"
	cppdialect "C++17"
	architecture "x86_64"

	targetdir "./%{prj.name}/build/%{cfg.buildcfg}"
	objdir "./%{prj.name}/build/%{cfg.buildcfg}/intermediates/"
	
	startproject("Editor")

	filter "configurations:Debug"
			defines {"DEBUG"}
			symbols "On"

	filter "configurations:Release"
		defines {"NDEBUG"}
		optimize "On"

		
include("./YoggieEngine")
include ("./Editor")


group("Other")
	includeexternal("./SandboxApp")
	includeexternal("./Runtime") 



group("Libraries")
  include('../ImGui')
  include("../ImGuizmo")
  include("../yaml-cpp")
